

#ifndef MAIN_H_
#define MAIN_H_

/*****************************************************************/
/********* INCLUDE                                       *********/
/*****************************************************************/
#include <msp430.h>

/*****************************************************************/
/********* MACROS                                        *********/
/*****************************************************************/

// I/O
#define PP1             0x0100
#define PP2             0x0200
#define P1orP2          (PP1|PP2)

#define P1OFF(x)        P1OUT &= ~(x & 0x00FF)
#define P1ON(x)         P1OUT |=  (x & 0x00FF)
#define P1TOGGLE(x)     P1OUT ^=  (x & 0x00FF)
#define P1DIR2OUT(x)    P1DIR |=  (x & 0x00FF)
#define P1DIR2IN(x)     P1DIR &= ~(x & 0x00FF)
#define P1SEL2ON(x)     P1SEL |=  (x & 0x00FF)
#define P1SEL2OFF(x)    P1SEL &= ~(x & 0x00FF)

#define P2OFF(x)        P2OUT &= ~(x & 0x00FF)
#define P2ON(x)         P2OUT |=  (x & 0x00FF)
#define P2TOGGLE(x)     P2OUT ^=  (x & 0x00FF)
#define P2DIR2OUT(x)    P2DIR |=  (x & 0x00FF)
#define P2DIR2IN(x)     P2DIR &= ~(x & 0x00FF)
#define P2SEL2ON(x)     P2SEL |=  (x & 0x00FF)
#define P2SEL2OFF(x)    P2SEL &= ~(x & 0x00FF)

#define PP1MSK(x)       ((x & PP1) >> 4)
#define PP2MSK(x)       ((x & PP2) >> 4)


// Delay Functions
//#define OSC_1MHz
#define MHz             1000
#define KHz             1

#ifdef OSC_1MHz
 //  1 MHz
 #define delay_ms(x)     __delay_cycles((long) x * 1000)
 #define delay_us(x)     __delay_cycles((long) x)
 #define XTAL_FREQ      (1*MHz)
#else
 // 16 MHz
 #define delay_ms(x)     __delay_cycles((long) x * 1000 * 16)
 #define delay_us(x)     __delay_cycles((long) x * 16)
 #define XTAL_FREQ      (16*MHz)
#endif


// States
#define LIGADO          1
#define DESLIGADO       0
#define ON              1
#define OFF             0


/*****************************************************************/
/********* FUNCTIONS                                     *********/
/*****************************************************************/
void WatchDogHold(void);

/*****************************************************************/
/********* END                                           *********/
/*****************************************************************/

#endif                                                /* MAIN_H_ */

